import createClient, {} from 'openapi-fetch';
import { FireblocksService } from './fireblocks.js';
export * from './validators.js';
export * from './openapi/schema.js';
export * from './utils.js';
export class Kiln {
    constructor({ apiToken, baseUrl, clientOptions }) {
        Object.defineProperty(this, "fireblocks", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "client", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        const client = createClient({
            ...clientOptions,
            baseUrl,
            headers: {
                ...(apiToken ? { Authorization: `Bearer ${apiToken}` } : {}),
                ...clientOptions?.headers,
            },
            querySerializer: { array: { explode: false, style: 'form' } },
        });
        this.fireblocks = new FireblocksService(client);
        this.client = client;
    }
}
//# sourceMappingURL=kiln.js.map